/* Copyright 2010 Greg Alexander.  See the file COPYING for terms */
/* $Id: midi.h,v 1.11 2010-02-08 03:17:28 greg Exp $ */
#ifndef MIDI_H
#define MIDI_H

#include "misc.h"

#if DEFINE_GLOBALS
#define __EXTERN__
#define EQUALS(x) = (x)
#else
#define __EXTERN__ extern
#define EQUALS(x)
#endif


#if defined(OSS_MIDI)
# define MIDI_DEVICE "/dev/midi"
#elif defined(COREAUDIO_MIDI)
#endif


__EXTERN__ int midi_fd EQUALS(-1);
__EXTERN__ double midi_freqtab[128];
__EXTERN__ const double midi_freqtab_base[128];
__EXTERN__ const char midi_notetab[128][4];

/* midi.c: */
int midi_init(void);
void midi_in(void);
void midi_cleanup(void);
void midi_record_cmd(char *arg);
void midi_play_step(void);
void midi_play_cmd(char *arg);
void midi_stop_cmd(void);
void midi_status_cmd(void);

/* keyboard.c: */
void keyboard_toggle(void);
void keyboard_poll(void);
void keyboard_note(unsigned char note, int down);
__EXTERN__ int keyboard_x_fd EQUALS(-1);


#undef __EXTERN__
#undef EQUALS

#endif /* MIDI_H */
