/* Copyright 2010 Greg Alexander.  See the file COPYING for terms */
/* $Id: misc.h,v 1.18 2010-02-08 07:38:21 greg Exp $ */
#ifndef MISC_H
#define MISC_H

#if DEFINE_GLOBALS
#define __EXTERN__
#define EQUALS(x) = (x)
#else
#define __EXTERN__ extern
#define EQUALS(x)
#endif

#if defined(MAEMO)
# define ALSA_SOUND 1
# define KEYBOARD_LINUX
#elif defined(__linux__)
# define ALSA_SOUND 1
# define OSS_MIDI
# define KEYBOARD_LINUX
#elif defined (__APPLE_CC__)
# define COREAUDIO_SOUND
# define COREAUDIO_MIDI
# define KEYBOARD_IBOOK
#else
# warning platform not detected
#endif


#define HIST_FILE ".ggb_history"
#define HIST_MAX 100000

#define HELP_FILE "ggb_help"
#define HELP_MAX_LINE 10240

#define SEARCH_MAX 100

#ifndef MAX
#define MAX(x,y) (((x)>(y)) ? (x) : (y))
#endif /* MAX */
#ifndef MIN
#define MIN(x,y) (((x)<(y)) ? (x) : (y))
#endif /* MIN */

/* misc.c: */
__EXTERN__ char *search_path[SEARCH_MAX];
void *safe_malloc(size_t len);
char *safe_strdup(char *s);
void assert_str(int b,char *s);
FILE *open_search(char *fn, char *mode);
char *extended_fn(char *fn, char *ext);

/* main.c: */
void do_cleanup(void);

/* cmd.c: */
extern int debug_flags;
void cmd_init(void);
void cmd_do(void);
void cmd_cleanup(void);
void cmd_doit(char *line);
void cmd_sysex(int number);
void cmd_note(unsigned char note, unsigned char attack);
char *cmd_inst_getname(void);

/* help.c: */
void help(char *args);

/* pattern.c: */
void pattern_cmd(char *args);
void pattern_stop(void);
void pattern_step(void);
void pattern_note(unsigned char note, unsigned char attack);

/* gyro.c: */
void gyro_start(char *fn, int bpm, int mode, int ofs);
void gyro_stop(void);
void gyro_step(void);
int gyro_note(unsigned char note, unsigned char vel);
void gyro_poll(void);
void gyro_cleanup(void);
__EXTERN__ int gyro_x_fd EQUALS(-1);

#undef __EXTERN__
#undef EQUALS

#endif /* MISC_H */
